VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsToolTip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'---------------------------------------------
'
'     clsToolTip.cls
'
'     Tooltip mehrzeilig
'     Autor:      peter.k.sauer@web.de
'     created:    09.2004
'     update:     24.09.2004
'---------------------------------------------
'wurde nur leicht abgendert d.h. die Verweise auf die Imagelist wurde entfernt

Option Explicit

'Api Deklaration fr Einfangen der Maus
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long

'Api Deklaration zum Ermitteln, ob eine Taste gedrckt wurde
Private Declare Function GetAsyncKeyState Lib "user32" _
                                 (ByVal vKey As Long) As Integer
Private Const VK_LBUTTON = &H1
Private Const VK_RBUTTON = &H2

'Api Deklarationen zum Laden/Anzeigen der Standardicons aus der MsgBox
Private Declare Function LoadStandardIcon Lib "user32" Alias _
                        "LoadIconA" (ByVal hInstance As Long, _
                        ByVal lpIconNum As StandardIconEnum) As Long

Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, _
                        ByVal x As Long, ByVal y As Long, _
                        ByVal hIcon As Long) As Long


Public Enum StandardIconEnum
    IDI_ASTERISK = 32516&
    IDI_EXCLAMATION = 32515&
    IDI_HAND = 32513&
    IDI_QUESTION = 32514
End Enum

'Einstellmglichkeiten fr den ToolTip, Basiseinstellungen in
'DefaultsSet, wird nach jeder Anzeige auf Default zurckgestellt
Private Type DefaultsType
   ForeColor As Long                      'Schriftfarbe
   BackColor As Long                      'Hintergrund
   BorderColor As Long                    'Rahmenfarbe
   BorderWidth As Long                    'Rahmenstrke
   TimeShow As Single                     'Anzeigedauer
   TimeDelay As Single                    'Zeit bis zur Anzeige
   Delimiter As String                    'Trennzeichen Zeilentrenne
   FontName As String                     'Fontname & Eigenschaften
   FontSize As Single
   FontBold As Boolean
   FontItalic As Boolean
   FontUnderLine As Boolean
   FontStrikethrough As Boolean
End Type
   
Private WithEvents Frm As Form            'Verweis auf Form
Attribute Frm.VB_VarHelpID = -1
Public WithEvents PicBox As PictureBox    'Picturebox fr die Anzeige
Attribute PicBox.VB_VarHelpID = -1
Private WithEvents mTimer As Timer        'zur automatischen Abschaltung
Attribute mTimer.VB_VarHelpID = -1

Private CtlHwnd As Long                   'Hwnd des aktuellen Controls
Private StartTime As Single               'wann gestartet
Private LastText As String                'zuletzt angezeigter Text
Private Defaults As DefaultsType          'Basiseinstellungen

Private mvartTop As Single                'Position ToolTip
Private mvartLeft As Single

Private mvarBackColor As Long             'BackColor ToolTip
Private mvarForeColor As Long             'ForeColor ToolTip

Private mvarTimeShow As Single            'maximal sichtbar Seconds
Private mvarTimeDelay As Single           'Seconds bis sichtbar

Private mvarDelimiter As String           'Zeilentrenner fr ToolTip
Private mvarBorderColor As Long           'RahmenFarbe
Private mvarBorderWidth As Long           'Rahmenstrke
Private mvarEnabled As Boolean            'ToolTip anzeigen

Public Property Let Enabled(ByVal vData As Boolean)
    mvarEnabled = vData
End Property

Public Property Get Enabled() As Boolean
    Enabled = mvarEnabled
End Property

Public Property Let BorderWidth(ByVal vData As Long)
    mvarBorderWidth = vData
End Property

Public Property Get BorderWidth() As Long
    BorderWidth = mvarBorderWidth
End Property

Public Property Let BorderColor(ByVal vData As Long)
    mvarBorderColor = vData
End Property

Public Property Get BorderColor() As Long
    BorderColor = mvarBorderColor
End Property

Public Property Let Delimiter(ByVal vData As String)
    mvarDelimiter = vData
End Property

Public Property Get Delimiter() As String
    Delimiter = mvarDelimiter
End Property

Public Property Let TimeDelay(ByVal vData As Single)
    mvarTimeDelay = vData
End Property

Public Property Get TimeDelay() As Single
    TimeDelay = mvarTimeDelay
End Property

Public Property Let TimeShow(ByVal vData As Single)
    mvarTimeShow = vData
End Property

Public Property Get TimeShow() As Single
    TimeShow = mvarTimeShow
End Property

Public Property Let ForeColor(ByVal vData As Long)
    mvarForeColor = vData
End Property

Public Property Get ForeColor() As Long
    ForeColor = mvarForeColor
End Property

Public Property Let BackColor(ByVal vData As Long)
    mvarBackColor = vData
End Property

Public Property Get BackColor() As Long
    BackColor = mvarBackColor
End Property

Public Property Let tLeft(ByVal vData As Single)
    mvartLeft = vData
End Property

Public Property Get tLeft() As Single
    tLeft = mvartLeft
End Property

Public Property Let tTop(ByVal vData As Single)
    mvartTop = vData
End Property

Public Property Get tTop() As Single
    tTop = mvartTop
End Property

'initialisieren
Public Sub Init(Parentform As Form)

      If Frm Is Nothing Then
         'Parentform Verweis
         Set Frm = Parentform
         'Tastatureingaben abfangen fr
         'Ausblenden ToolTip
         Frm.KeyPreview = True
         'Controls auf Form plazieren
         PicBoxGenerate
         
         
         'Basiseinstellungen vornehmen
         DefaultsSet
      End If
End Sub

'einen ToolTip anzeigen
Public Sub ShowToolTip(Ctl As Control, Text As String, _
                       ByVal MouseX As Single, ByVal MouseY As Single, _
                       Optional mTop As Variant, Optional mLeft As Variant, _
                       Optional Alignment As AlignmentConstants = vbLeftJustify, _
                       Optional mStandardIcon As StandardIconEnum = 0, _
                       Optional ImageListNumber As Long = 0)

   Dim s() As String
   Dim w As Variant, h As Variant
   Dim x As Single, x1 As Single, y As Single
   Dim i As Long
   Dim CtlC As Control
      
      'Tooltip anzeigen ja/nein
      If Not Enabled Then
         Exit Sub
      End If
      
      'Mausclick neutralisieren
      GetAsyncKeyState VK_LBUTTON
      GetAsyncKeyState VK_RBUTTON
      
      'ist Maus ausserhalb des Controls
      If MouseX <= 0 Or MouseY <= 0 Or MouseX >= Ctl.Width Or MouseY >= Ctl.Height Then
         'Mouse freigeben
         mTimer.Enabled = False
         ReleaseCapture
         CtlHwnd = 0
         PicBox.Visible = False
         'Grundeinstellungen zurckstellen
         DefaultsSetBack
         Exit Sub
      End If

      'noch gleiches Control
      If CtlHwnd = Ctl.hwnd Then
         'Maus (erneut) einfangen
         SetCapture CtlHwnd
         'bei gleichem Text hier abbrechen
         If LastText = Text Then
            Exit Sub
         End If
      End If
      
      'Maus einfangen
      CtlHwnd = Ctl.hwnd
      SetCapture CtlHwnd
         
      'Text aufdrseln
      s() = Split(Text, mvarDelimiter)
      'und sichern
      LastText = Text
      'Breite feststellen
      For i = LBound(s) To UBound(s)
         s(i) = Space(2) & s(i) & Space(2)
         If PicBox.TextWidth(s(i)) > w Then
            w = PicBox.TextWidth(s(i))
         End If
      Next
      
      'bei StandardIcon Breite anpassen
      If mStandardIcon > 0 Then
         x1 = 45 * Screen.TwipsPerPixelX
         PicBox.Width = w + x1
         w = PicBox.Width
      End If
      
      'Hhe feststellen
      h = PicBox.TextHeight(s(LBound(s))) * (UBound(s) + 1)
      h = h + PicBox.TextHeight(s(LBound(s))) / 2
      
      'Picbox plazieren
      With PicBox
         .Width = w
         .Height = h
         If IsMissing(mTop) Then
            .Top = Ctl.Top + Ctl.Height + 90
         Else
            .Top = mTop
         End If
         If IsMissing(mLeft) Then
            .Left = Ctl.Left + 90
         Else
            .Left = mLeft
         End If
         
         'ist Container ein Frame oder eine PicBox
         If Not Ctl.Container Is Frm Then
            'Top und Left synchronisieren
            .Top = .Top + Ctl.Container.Top
            .Left = .Left + Ctl.Container.Left
            
            'ggf weitere Container
            Set CtlC = Ctl.Container
            Do
               If CtlC.Container Is Frm Then
                  Exit Do
               End If
               .Top = .Top + CtlC.Container.Top
               .Left = .Left + CtlC.Container.Left
               Set CtlC = CtlC.Container
            Loop
            Set CtlC = Nothing
         End If
         .Cls
      End With
      
      'darauf achten, dass die Box sichbar ist
      With PicBox
         'innerhalb der Form
         x = Frm.ScaleWidth - .Left - .Width
         If x < 0 Then
            .Left = .Left + x
         End If
         y = Frm.ScaleHeight - .Top - .Height
         If y < 0 Then
            .Top = .Top + y
         End If
         
         'bei Verschieben der Form nach rechts oder links
         x = Frm.Left + .Left
         If x < 0 Then
            .Left = .Left - x
         End If
         x = Frm.Left + .Left + .Width + 4 * Screen.TwipsPerPixelX
         If x > Screen.Width Then
            .Left = .Left - x + Screen.Width
         End If
      End With
      
      'Farben setzen
      PicBox.ForeColor = mvarForeColor
      PicBox.BackColor = mvarBackColor
      
      'Standardicon einfgen
      If mStandardIcon > 0 Then
         StandardIconDraw mStandardIcon
      End If
      
      'Picbox beschriften
      PicBox.CurrentY = PicBox.TextHeight(s(LBound(s))) / 4
      For i = LBound(s) To UBound(s)
         If Alignment = vbLeftJustify Then
            PicBox.CurrentX = x1
         ElseIf Alignment = vbRightJustify Then
            PicBox.CurrentX = PicBox.Width - PicBox.TextWidth(s(i))
         ElseIf Alignment = vbCenter Then
            PicBox.CurrentX = (PicBox.Width - PicBox.TextWidth(s(i)) + x1) / 2
         End If
         PicBox.Print s(i)
      Next
      
      'Rahmen ziehen
      x = Screen.TwipsPerPixelX
      y = Screen.TwipsPerPixelY
      With PicBox
         For i = 0 To mvarBorderWidth - 1
            PicBox.Line (i * x, i * y)-Step _
                         (.Width - (i * 2 + 1) * x, _
                         .Height - (i * 2 + 1) * y), _
                         mvarBorderColor, B
         Next
      End With
      
      'Anzeige verzgert starten
      StartTime = Timer
      mTimer.Interval = 100
      mTimer.Enabled = True
End Sub

'ein StandardIcon (aus MsgBox) anzeigen
Private Function StandardIconDraw(IconNumber As Long) As Boolean

   Dim lIcon As Long
   Dim x As Long, y As Long
   
      x = 10
      y = 10
      lIcon = LoadStandardIcon(0&, IconNumber)
      Call DrawIcon(PicBox.hdc, x, y, lIcon)
End Function

'Picturebox auf Form plazieren
Private Sub PicBoxGenerate()

   Dim i As Long
   
      i = 4711
      On Error Resume Next
      Do
         'die Picturebox plazieren
         Set PicBox = Frm.Controls.Add("VB.Picturebox", "ToolTipPicBox" & i)
         If Err.Number = 0 Then
            Exit Do
         End If
         'der Name war bereits vergeben
         i = i + 1
      Loop
      Err.Clear
      
      'Properties einstellen
      With PicBox
         .AutoRedraw = True
         .BorderStyle = 0
      End With
      
      On Error Resume Next
      Do
         'den Timer plazieren
         Set mTimer = Frm.Controls.Add("VB.Timer", "ToolTipTimer" & i)
         If Err.Number = 0 Then
            Exit Do
         End If
         i = i + 1
      Loop
      On Error GoTo 0
      
      'Properties einstellen
      mTimer.Interval = 100
      mTimer.Enabled = False
End Sub

'Basiseinstellungen bernehmen
Public Sub DefaultsSet(Optional mForeColor As SystemColorConstants = vbWindowText, _
                       Optional mBackColor As SystemColorConstants = vbInfoBackground, _
                       Optional mBorderColor As SystemColorConstants = vbWindowText, _
                       Optional mBorderWidth As Long = 1, _
                       Optional mTimeShow As Single = 4, _
                       Optional mTimeDelay As Single = 0.3, _
                       Optional mDelimiter As String = "|", _
                       Optional mFontName As String = "MS Sans Serif", _
                       Optional mFontSize As Single = 8.25, _
                       Optional mFontBold As Boolean = False, _
                       Optional mFontItalic As Boolean = False, _
                       Optional mFontUnderline As Boolean = False, _
                       Optional mFontStrikethrough As Boolean = False)
                       
      With Defaults
         .ForeColor = mForeColor
         .BackColor = mBackColor
         .BorderColor = mBorderColor
         .BorderWidth = mBorderWidth
         .TimeShow = mTimeShow
         .TimeDelay = mTimeDelay
         .Delimiter = mDelimiter
         .FontName = mFontName
         .FontSize = mFontSize
         .FontBold = mFontBold
         .FontItalic = mFontItalic
         .FontUnderLine = mFontUnderline
         .FontStrikethrough = mFontStrikethrough
      End With
      
      'Properties einstellen
      DefaultsSetBack
End Sub

'Properties auf Defaultwerte (zurck)setzen
Private Sub DefaultsSetBack()

      With Defaults
         mvarForeColor = .ForeColor
         mvarBackColor = .BackColor
         mvarBorderColor = .BorderColor
         mvarBorderWidth = .BorderWidth
         mvarTimeShow = .TimeShow
         mvarTimeDelay = .TimeDelay
         mvarDelimiter = .Delimiter
         
         PicBox.Font.Name = .FontName
         PicBox.Font.Size = .FontSize
         PicBox.Font.Bold = .FontBold
         PicBox.Font.Italic = .FontItalic
         PicBox.Font.Underline = .FontUnderLine
         PicBox.Font.Strikethrough = .FontStrikethrough
      End With
End Sub

'Tooltip abstellen wenn Taste gedrckt
Private Sub Frm_KeyDown(KeyCode As Integer, Shift As Integer)

      If PicBox Is Nothing Then
         Exit Sub
      End If
      
      If PicBox.Visible Then
         PicBox.Visible = False
         mTimer.Enabled = False
         'Grundeinstellungen zurckstellen
         DefaultsSetBack
      End If
End Sub

'Tooltip an- bzw abschalten
Private Sub mTimer_Timer()

   Dim aTime As Single
   
      aTime = Timer
      'Geisterstunde bercksichtigen
      If aTime < StartTime Then
         aTime = aTime + 3600& * 24&
      End If
      
      'prfen ob Zeit fr Anzeige berschritten
      If aTime > (StartTime + mvarTimeDelay + mvarTimeShow) Then
         PicBox.Visible = False
         mTimer.Enabled = False
         'Grundeinstellungen zurckstellen
         DefaultsSetBack
      Else
         'wenn noch nicht sichtbar
         If Not PicBox.Visible Then
            'prfen ob Delay(zeit) abgelaufen
            If aTime > (StartTime + mvarTimeDelay) Then
               PicBox.Visible = True
               PicBox.ZOrder 0
            End If
         End If
      End If
      
      'bei Mausclick Tooltip ausblenden
      If GetAsyncKeyState(VK_LBUTTON) Or GetAsyncKeyState(VK_RBUTTON) Then
         PicBox.Visible = False
         mTimer.Enabled = False
         'Grundeinstellungen zurckstellen
         DefaultsSetBack
      End If
End Sub

Private Sub Class_Initialize()

      'Basiseinstellungen in DefaultSet
      'wird im Init aufgerufen
      
      'Anzeige verfgbar
      mvarEnabled = True
      
      'Mouse neutralisieren
      GetAsyncKeyState VK_LBUTTON
      GetAsyncKeyState VK_RBUTTON
End Sub

Private Sub Class_Terminate()

      'Speicher freigeben
      If Not (PicBox Is Nothing) Then
         Frm.Controls.Remove PicBox
         Frm.Controls.Remove mTimer
         
         Set PicBox = Nothing
         Set mTimer = Nothing
         Set Frm = Nothing
      End If
      
      'Maus freigeben
      If CtlHwnd > 0 Then
         ReleaseCapture
      End If
End Sub
